/*  Project: Open Source Gmini Tools
    file: Breakpoint.h, header file for Breakpoint.cpp

    Copyright (C) 2004  The gmEmu Project <gmemu@donat.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef Breakpoint_H
#define Breakpoint_H

#include "types.h"

class Breakpoint {
 public:
   enum brktype_t { EXECUTION, MEMORY, MEMORY_RANGE };
   static const unsigned int R, W, X;
 private:
      brktype_t type;
 protected:
      Breakpoint( brktype_t type );
   bool enabled;
 public:
      brktype_t get_type(  );
   void enable(  );
   void disable(  );
   virtual const void Print(  ) = 0;
   virtual const bool is( const u22 address, unsigned int access ) = 0;
};
class BreakpointX:public Breakpoint {
 protected:
   u22 address;
 public:
   BreakpointX( u22 address );
   const bool is( const u22 address, unsigned int access );
   const void Print(  );
};

class BreakpointM:public Breakpoint {
 protected:
   unsigned int access;
   u22 address;
 public:
      BreakpointM( u22 address, unsigned int access );
   const bool is( const u22 address, unsigned int access );
   const void Print(  );
};

class BreakpointR:public Breakpoint {
 protected:
   u22 start;
   u22 end;
   unsigned int access;
 public:
      BreakpointR( u22 start, u22 end, unsigned int access );
   const bool is( const u22 address, unsigned int access );
   const void Print(  );
};

#endif
