/*  Project: Open Source Gmini Tools
    file: emu.cpp, main procedure for gmemu

    Copyright (C) 2004  The gmEmu Project <gmemu@donat.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdlib.h>
#include <signal.h>
#include <iostream>
using namespace std;
#include "types.h"
#include "parsecmd.hh"
#include "Emulator.h"

#define DEFAULT_FN "aaz/FirmwareGmini100_v1100.aaz"
#define DEFAULT_CM "map/FirmwareGmini100_v1100.map"

bool cmdexit;

Emulator *gmini;

int emu( int argc, const char *argv[] ) {


   gmini = new Emulator( argc-1, argv+1 );

   startparser(  );
   while( !cmdexit ) {
      parsecmd( gmini );
   }
   stopparser(  );

   delete gmini;
   return 0;
}
#ifndef __CYGWIN__
void sig_handler( int signo ) {
   if( ( signo != SIGSEGV ) && ( signo != SIGBUS ) && ( signo != SIGIOT ) )
      signal( signo, ( &sig_handler ) );
   else
      signal( signo, SIG_DFL );
   switch ( signo ) {
      case SIGINT:
         gmini->cpu.sigint(  );
         break;
      default:
         abort(  );
   }
}
#endif
int main( int argc, const char **argv ) {
#ifndef __CYGWIN__
//    signal( SIGTERM, ( &sig_handler ) );
//    signal( SIGALRM, ( &sig_handler ) );
//    signal( SIGFPE, ( &sig_handler ) );
//    signal( SIGHUP, ( &sig_handler ) );
//    signal( SIGILL, ( &sig_handler ) );
   signal( SIGINT, ( &sig_handler ) );
//    signal( SIGIO, ( &sig_handler ) );
//    signal( SIGPIPE, ( &sig_handler ) );
//    signal( SIGPROF, ( &sig_handler ) );
//    signal( SIGQUIT, ( &sig_handler ) );
//    signal( SIGSTOP, ( &sig_handler ) );
//    signal( SIGTERM, ( &sig_handler ) );
//    signal( SIGTSTP, ( &sig_handler ) );
//    signal( SIGTTIN, ( &sig_handler ) );
//    signal( SIGTTOU, ( &sig_handler ) );
//    signal( SIGUSR1, ( &sig_handler ) );
//    signal( SIGUSR2, ( &sig_handler ) );
//    signal( SIGVTALRM, ( &sig_handler ) );
//    signal( SIGXCPU, ( &sig_handler ) );
//    signal( SIGXFSZ, ( &sig_handler ) );
//    signal( SIGSEGV, ( &sig_handler ) );
#endif
   return emu( argc, argv );
}
