
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "types.h"
#include "util.h"


int processAAZ( const char *file ) {
   u8 *aaz;
   int length;
   if( ( length = loadFile( file, &aaz ) ) == -1 )
      return -1;

   
   u32 flash_size = length - 0x100;
   u16 chksum = chksum32( aaz + 0x100, flash_size ) & 0xffff;

   bu32((char*) aaz + 8, flash_size );
   bu16((char*) aaz + 16, chksum );
   
   writeFile( file, aaz, length );
   
   delete aaz;
   return 1;
}

int main( int argc, char **argv ) {
   int n = 1;
   if( argc < 2 )
      printf( "Usage: %s file.aaz ...]\n", argv[0] );
   else
      for( ; n < argc; ++n ) {
         processAAZ( argv[n] );
      }
   return 0;
}
