


#ifndef MMIO_H
#define MMIO_H

#include "types.h"

#define IOBASE (0x3f0000)
#define MMIO(t, x) (*(volatile t*)(IOBASE+(x))) 

#define WDTEN MMIO(unsigned char, 0x06)
#define WDTCON MMIO(u8, 0x07)

#define LCON  MMIO(u8, 0x0b0)
#define UCON  MMIO(u8, 0x0b1)
#define USSR  MMIO(u8, 0x0b2)
#define TBR   MMIO(u8, 0x0b3)
#define RBR   MMIO(u8, 0x0b4)
#define UBRDR MMIO(u8, 0x0b5)
#define UPEND MMIO(u8, 0x0b6)


#define TACON  MMIO(u8, 0x08)
#define TAPRE  MMIO(u8, 0x09)
#define TADATA MMIO(u16, 0x0A)
#define TACNT MMIO(u16, 0x0C)

#define IMR0 MMIO(u16, 0x22)
#define IMR1 MMIO(u16, 0x2A)

#define P0 MMIO(u8, 0x30)
#define P1 MMIO(u8, 0x31)
#define P2 MMIO(u8, 0x32)

#define ADDATA MMIO(u16, 0x74)
#define ADCON MMIO(u8, 0x76)

#define PLL0DATA MMIO(u8, 0xA8)
#define PLL0CON MMIO(u16, 0xAA)

#define DDMACOM MMIO(u8, 0x120)
#define DDMACFG MMIO(u8, 0x121)
#define DDMAIADR MMIO(u32, 0x122)
#define DDMAEADR MMIO(u32, 0x126)
#define DDMANUM MMIO(u16, 0x12A)
#define DDMACNT MMIO(u16, 0x12C)


#endif
